proc makemachine machine {
  upvar sock sock
  upvar nodex nodex
  upvar nodey nodey
  upvar nodeangle nodeangle
  upvar identifier identifier

  set j 0

  #work out the number of rows to make
  set m [llength $machine]

  while {$j<$m} {
    set currentrow [lindex $machine $j]
    set currentrowhandles {}

    set n [llength $currentrow]
    set i 0

    right 90
    while {$i<$n} {
      if {![string equal [lindex [lindex $currentrow $i] 0] null]} {
	left 90
	right [lindex [lindex $currentrow $i] 1]
        set ch [placenode [lindex [lindex $currentrow $i] 0] ]
	left [lindex [lindex $currentrow $i] 1]
	right 90

        lappend currentrowhandles $ch

        if {$i>0 && [set ph [lindex $currentrowhandles [expr $i - 1]]]} {
          connect $ph $ch
        }

        if {$j>0 && $i<[llength $previousrowhandles]} {
          if {[set ph [lindex $previousrowhandles $i]]} {
            connect $ph $ch
          }
        }
      } else {
        lappend currentrowhandles 0
      }

      set i [expr $i + 1]
      forward 16
    }
    forward [expr -16*$n]

    left 90
    forward -16
    set j [expr $j + 1]
    set previousrowhandles $currentrowhandles
  }
  forward [expr $m * 16]
}



#Create a line of Store nodes with information to construct the nodes
#passed in 'types'
proc makedna {types} {
  set nothing -1
  set store 0
  set ins 1
  set wire 2
  set not 3
  set thrust 4
  set fuse 5
  set rfuse 6
  set lfuse 7
  set toggle 8
  set delta 9
  set ndelta 10
  set detect 11
  set or 12
  set runfuse 13
  set lunfuse 14
  set cross 15
  set keypress 16
  set pulse 17
  set rslide 18
  set lslide 19
  set creator 20
  set maj 21
  set notnot 22
  set push 23
  set equal 24
  set numtypes 25

  upvar sock sock
  upvar nodex nodex
  upvar nodey nodey
  upvar nodeangle nodeangle
  upvar identifier identifier

  set n [llength $types]
  set i 0
  set oldn 0

  puts $n

  while {$i<$n} {
    set nodenum [set [lindex [lindex $types $i] 0]]
    set nodedir [lindex [lindex $types $i] 1]

    set newn [placenode store]

    #Now put the correct value into the store node

    if {$nodenum != -1} {
      setnum $newn [expr $nodenum * 4 + $nodedir + 1]
    } else {
      setnum $newn [expr $numtypes*4 + 1]
    }

    if {$newn && $oldn} {
      connect $newn $oldn
    }

    left 90
    forward 16
    right 90

    set i [expr $i + 1]
    set oldn $newn
  }
}

