set sock [open nodes.inp w]

set nodex 0
set nodey 0
set nodeangle 0
set identifier 1
set posstack {}

proc connect {n1 n2} {
  upvar sock s
  puts $s "connect $n1 $n2\n"
}

proc setnum {n num} {
  upvar sock s
  puts $s "setnum $n $num\n"
}

proc placenode type {
  upvar nodex x
  upvar nodey y
  upvar nodeangle a
  upvar identifier id

  upvar sock s
  puts $s "node $id $type $x $y [expr $a*6.2832/360] 8\n"

  set rval $id
  set id [expr $id + 1]

  return $rval
}

proc nodeatpos {} {
  upvar nodex x
  upvar nodey y
  upvar identifier id
  upvar sock s

  puts $s "nodeatpos $id $x $y\n"

  set rval $id
  set id [expr $id + 1]

  return $rval
}

proc placenodea {type ang} {
  upvar nodex x
  upvar nodey y
  upvar identifier id

  upvar sock s
  puts $s "node $id $type $x $y [expr $ang*6.2832/360] 8\n"

  set rval $id
  set id [expr $id + 1]

  return $rval
}


proc forward dist {
  upvar nodex x
  upvar nodey y
  upvar nodeangle a

  set x [expr $x + $dist * sin($a*2*3.141592/360)]
  set y [expr $y + $dist * cos($a*2*3.141592/360)]
}

proc right ang {
  upvar nodeangle a
  set a [expr $a + $ang]
}

proc left ang {
  upvar nodeangle a
  set a [expr $a - $ang]
}

proc pushpos {} {
  upvar nodex nodex
  upvar nodey nodey
  upvar nodeangle nodeangle
  upvar posstack posstack

  lappend posstack $nodex
  lappend posstack $nodey
  lappend posstack $nodeangle
}

proc poppos {} {
  upvar nodex nodex
  upvar nodey nodey
  upvar nodeangle nodeangle
  upvar posstack posstack

  set nodeangle [lindex $posstack end]
  set posstack [lreplace $posstack end end]
  set nodey [lindex $posstack end]
  set posstack [lreplace $posstack end end]
  set nodex [lindex $posstack end]
  set posstack [lreplace $posstack end end]
}

